@import './styles/digi-docs-color-swatch.variables.scss';

:host {
  display: block;
}

.digi-docs-color-swatch {
  @include digi-docs-color-swatch--variables();

  $base: &;

  font-weight: var(--digi--typography--description--font-weight--desktop);

  --digi--color--border--primary: var(--digi-docs-color-swatch--border-color);

  #{$base}__color {
    display: inline-flex;
    border: solid var(--digi--border-width--primary)
      var(--digi--color--border--primary);
    background: var(--digi-docs-color-swatch--background);

    &::before {
      content: '';
      display: inline-block;
    }
  }

  // VARIATIONS
  &--rectangle {
    #{$base}__color {
      min-width: var(--digi--padding--largest-2);
      box-sizing: border-box;
      padding: var(--digi--padding--smaller);

      &::before {
        content: '';
        display: block;
        padding-bottom: 100%;
      }
    }
  }

  &--circle {
    #{$base}__color {
      display: flex;
      align-items: center;
      justify-content: center;
      width: var(--digi-docs-color-swatch--size);
      height: var(--digi-docs-color-swatch--size);
      border-radius: var(--digi-docs-color-swatch--size);
    }

    &#{$base}--selected {
      #{$base}__color {
        box-shadow:
          inset 0 0 0px 2px var(--digi-docs-color-swatch--background),
          inset 0 0 0px 4px var(--digi-docs-color-swatch--selected-color);
      }
    }
  }

  &--full {
    #{$base}__color {
      display: flex;
      width: 100%;
      box-sizing: border-box;
      padding: var(--digi--padding--smaller);

      &::before {
        content: '';
        display: block;
        margin-bottom: 100%;
      }

      > div {
        display: flex;
        flex-direction: column;
        justify-content: space-between;
      }

      h3 {
        margin: 0;
      }
    }
  }

  // SIZES
  &--s {
    --digi-docs-color-swatch--size: var(--digi-docs-color-swatch--size--s);
  }

  &--m {
    --digi-docs-color-swatch--size: var(--digi-docs-color-swatch--size--m);
  }

  &--l {
    --digi-docs-color-swatch--size: var(--digi-docs-color-swatch--size--l);
  }
}
